"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var util_1 = require("../../util");
var di_1 = require("../../di");
var definition_1 = require("../../definition");
var WebBootstrapper = /** @class */ (function () {
    function WebBootstrapper() {
    }
    /**
     * @stable [01.10.2019]
     * @param {() => void} callback
     */
    WebBootstrapper.prototype.init = function (callback) {
        var _this = this;
        var environment = this.environment;
        var document = environment.document;
        var ready = function () {
            _this.applyClasses();
            _this.addRootElement();
            callback();
        };
        this.initGA();
        this.initErrorHandler();
        switch (document.readyState) {
            case 'loading':
            case 'interactive':
                // We cannot use DOMContentLoaded because fonts loading and UI blinking
                this.eventManager.add(environment.window, definition_1.EventsEnum.LOAD, ready);
                break;
            case 'complete':
                ready();
                break;
        }
    };
    /**
     * @stable [01.10.2019]
     */
    WebBootstrapper.prototype.addRootElement = function () {
        this.domAccessor.addClassNames(this.domAccessor.addRootElement(), util_1.orNull(this.bSettings.flexEnabled, 'rac-flex'));
    };
    /**
     * @stable [01.10.2019]
     */
    WebBootstrapper.prototype.initErrorHandler = function () {
        var _this = this;
        this.domAccessor.defineGlobalErrorHandler(function (e) { return _this.uiFactory.makeWindowError(e); });
    };
    /**
     * @stable [01.10.2019]
     */
    WebBootstrapper.prototype.initGA = function () {
        var environment = this.environment;
        if (environment.prodMode && environment.googleKey) {
            this.gtag('js', new Date());
            this.gtag('config', environment.googleKey);
            if (util_1.isFn(this.window.ga)) {
                this.window.ga('create', environment.googleKey, 'auto');
            }
        }
    };
    /**
     * @stable [01.10.2019]
     */
    WebBootstrapper.prototype.applyClasses = function () {
        var environment = this.environment;
        var document = environment.document;
        this.domAccessor.addClassNames(document.body, 'rac', environment.appProfile, environment.mobilePlatform ? 'rac-mobile' : 'rac-desktop', util_1.orNull(environment.androidPlatform, 'rac-android'), util_1.orNull(environment.iosPlatform, 'rac-ios'), util_1.orNull(environment.macPlatform, 'rac-mac'), util_1.orNull(environment.safariPlatform, 'rac-safari'));
    };
    /**
     * @stable [01.10.2019]
     * @param args
     */
    WebBootstrapper.prototype.gtag = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var dL = this.window.dataLayer = this.window.dataLayer || [];
        dL.push(arguments);
    };
    Object.defineProperty(WebBootstrapper.prototype, "bSettings", {
        /**
         * @stable [@stable [01.10.2019]]
         * @returns {IBootstrapSettings}
         */
        get: function () {
            return this.settings.bootstrap || {};
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebBootstrapper.prototype, "window", {
        /**
         * @stable [01.10.2019]
         * @returns {Window}
         */
        get: function () {
            return this.environment.window;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.DomAccessor),
        __metadata("design:type", Object)
    ], WebBootstrapper.prototype, "domAccessor", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Environment),
        __metadata("design:type", Object)
    ], WebBootstrapper.prototype, "environment", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.EventManager),
        __metadata("design:type", Object)
    ], WebBootstrapper.prototype, "eventManager", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Settings),
        __metadata("design:type", Object)
    ], WebBootstrapper.prototype, "settings", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.UIFactory),
        __metadata("design:type", Object)
    ], WebBootstrapper.prototype, "uiFactory", void 0);
    WebBootstrapper = __decorate([
        inversify_1.injectable()
    ], WebBootstrapper);
    return WebBootstrapper;
}());
exports.WebBootstrapper = WebBootstrapper;
//# sourceMappingURL=web-bootstrapper.service.js.map