/// <reference types="react" />
import { ILogger } from 'ts-smart-logger';
import { BaseTextField } from '../../field/textfield';
import { AnyT, IKeyboardEvent } from '../../../definitions.interface';
import { IBaseSelectProps, IBaseSelectState } from './base-select.interface';
import { IBaseEvent, ISelectOptionEntity } from '../../../definition';
export declare class BaseSelect<TProps extends IBaseSelectProps, TState extends IBaseSelectState> extends BaseTextField<TProps, TState> {
    protected static readonly logger: ILogger;
    private readonly menuRef;
    /**
     * @stable [30.11.2019]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [30.11.2019]
     * @param {Readonly<TProps extends IBaseSelectProps>} prevProps
     * @param {Readonly<TState extends IBaseSelectState>} prevState
     */
    componentDidUpdate(prevProps: Readonly<TProps>, prevState: Readonly<TState>): void;
    onKeyBackspace(event: IKeyboardEvent): void;
    onKeyEnter(event: IKeyboardEvent): void;
    onKeyEscape(event: IKeyboardEvent): void;
    /**
     * @stable [30.11.2019]
     */
    clearValue(): void;
    /**
     * @stable [30.11.2019]
     * @param {IBaseEvent} event
     */
    openMenu(event?: IBaseEvent): void;
    /**
     * @stable [30.11.2019]
     * @returns {boolean}
     */
    readonly inProgress: boolean;
    /**
     * @stable [25.02.2019]
     * @param {IBaseEvent} event
     */
    protected onClick(event: IBaseEvent): void;
    /**
     * @stable [01.06.2018]
     * @returns {JSX.Element}
     */
    protected getInputAttachmentElement(): JSX.Element;
    /**
     * @stable [30.11.2019]
     * @returns {ISelectOptionEntity[]}
     */
    protected readonly filteredOptions: ISelectOptionEntity[];
    protected getFieldClassName(): string;
    /**
     * @stable [29.06.2018]
     * @returns {AnyT}
     */
    protected getEmptyValue(): AnyT;
    /**
     * @stable [30.11.2019]
     * @param {ISelectOptionEntity} option
     */
    protected onSelect(option: ISelectOptionEntity): void;
    /**
     * @stable [10.09.2019]
     */
    protected onClose(): void;
    /**
     * @stable [12.02.2019]
     * @param {AnyT} value
     * @returns {AnyT}
     */
    protected getDecoratedValue(value: AnyT): AnyT;
    /**
     * @stable [20.08.2018]
     * @returns {ISelectOptionEntity[]}
     */
    protected readonly options: ISelectOptionEntity[];
    /**
     * @stable [30.11.2019]
     */
    private showMenu;
    /**
     * @stable [20.08.2018]
     */
    private hideMenu;
    private onFilterChange;
    /**
     * @stable [23.11.2019]
     * @returns {number}
     */
    private readonly menuWidth;
    /**
     * @stable [30.11.2019]
     * @returns {IMenu}
     */
    private readonly menu;
}
