import { IFieldProps, ITabConfiguration, ITabPanelConfiguration } from '../../configurations-definitions.interface';
import { IFormProps, IGenericFormEntity } from '../../definition';
import { IEntity } from '../../definitions.interface';
/**
 * @stable [29.05.2018]
 * @param {IFormProps} formProps
 * @param {IFieldProps} fieldProps
 * @returns {boolean}
 */
export declare const isFormFieldDisabled: (formProps: IGenericFormEntity, fieldProps: IFieldProps) => boolean;
/**
 * @stable [16.11.2018]
 * @param {IFormProps} formProps
 * @param {IFieldProps} fieldProps
 * @returns {boolean}
 */
export declare const isFormFieldChangeable: (formProps: IFormProps<IEntity>, fieldProps: IFieldProps) => boolean;
/**
 * @stable [16.11.2018]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormChangeable: (formProps: IFormProps<IEntity>) => boolean;
/**
 * @stable [29.05.2018]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormDirty: (formProps: IFormProps<IEntity>) => boolean;
/**
 * @stable [03.08.2018]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormSubmittable: (formProps: IFormProps<IEntity>) => boolean;
/**
 * @stable [15.02.2019]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormResettable: (formProps: IFormProps<IEntity>) => boolean;
/**
 * @stable [29.05.2018]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormOfNewEntity: (formProps: IFormProps<IEntity>) => boolean;
/**
 * @stable [30.08.2018]
 * @param {IFormProps} formProps
 * @param {ITabConfiguration} tab
 * @returns {boolean}
 */
export declare const isFormTabActive: (formProps: IFormProps<IEntity>, tab: ITabConfiguration) => boolean;
/**
 * @stable [30.08.2018]
 * @param {IFormProps} formProps
 * @param {ITabPanelConfiguration} tabPanelConfiguration
 * @returns {number}
 */
export declare const getFormTabActiveValue: (formProps: IFormProps<IEntity>, tabPanelConfiguration: ITabPanelConfiguration) => number;
