"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var base_1 = require("../../base");
var util_1 = require("../../../util");
var BaseGridColumn = /** @class */ (function (_super) {
    __extends(BaseGridColumn, _super);
    function BaseGridColumn() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [17.10.2019]
     * @param {TProps} style
     * @returns {React.CSSProperties}
     */
    BaseGridColumn.prototype.getStyle = function (style) {
        return util_1.defValuesFilter({
            width: util_1.nvl(style && style.width, this.props.width),
        });
    };
    /**
     * @stable [18.10.2019]
     * @param {string} classNames
     * @returns {string}
     */
    BaseGridColumn.prototype.getClassName = function () {
        var classNames = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            classNames[_i] = arguments[_i];
        }
        var props = this.props;
        return util_1.joinClassName.apply(void 0, ['rac-grid-column',
            util_1.isIndexed(props) && util_1.isNumber(props.index) && "rac-grid-column-" + props.index,
            util_1.isOddNumber(props.index) && 'rac-grid-column-odd',
            util_1.isEdited(props) && 'rac-grid-column-edited',
            util_1.isSortable(props) && 'rac-grid-column-sortable',
            props.align && "rac-grid-column-align-" + props.align,
            props.className].concat(classNames));
    };
    Object.defineProperty(BaseGridColumn.prototype, "columnContentElement", {
        /**
         * @stable [26.10.2019]
         * @returns {JSX.Element}
         */
        get: function () {
            var _this = this;
            return util_1.ifNotNilThanValue(this.props.children, function (children) { return (React.createElement("div", { className: 'rac-grid-column-content' }, _this.getColumnContentChildrenElement(children))); });
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [22.10.2019]
     * @param {React.ReactNode} children
     * @returns {React.ReactNode}
     */
    BaseGridColumn.prototype.getColumnContentChildrenElement = function (children) {
        return children;
    };
    return BaseGridColumn;
}(base_1.UniversalComponent));
exports.BaseGridColumn = BaseGridColumn;
//# sourceMappingURL=base-grid-column.component.js.map