"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var base_1 = require("../../base");
var util_1 = require("../../../util");
var definition_1 = require("../../../definition");
var GridRow = /** @class */ (function (_super) {
    __extends(GridRow, _super);
    /**
     * @stable [23.10.2019]
     * @param {IGridRowProps} props
     */
    function GridRow(props) {
        var _this = _super.call(this, props) || this;
        _this.onClick = _this.onClick.bind(_this);
        return _this;
    }
    /**
     * @stable [23.10.2019]
     * @returns {JSX.Element}
     */
    GridRow.prototype.render = function () {
        var _this = this;
        var props = this.props;
        var entity = props.entity;
        return (React.createElement(definition_1.UniversalScrollableContext.Consumer, null, function (selectedElementClassName) { return (React.createElement("tr", __assign({ ref: _this.selfRef, className: util_1.joinClassName('rac-grid-row', props.className, props.indexed && !R.isNil(entity) && "rac-grid-row-" + entity.id, props.grouped && 'rac-grid-row-grouped', props.filter && 'rac-grid-row-filter', props.groupExpanded && 'rac-grid-row-group-expanded', props.hovered && 'rac-grid-row-hovered', props.odd && 'rac-grid-row-odd', props.partOfGroup && 'rac-grid-row-part-of-group', props.total && 'rac-grid-row-total', props.selectable && 'rac-grid-row-selectable', props.selected && "rac-grid-row-selected " + selectedElementClassName) }, util_1.handlerPropsFactory(_this.onClick, props.selectable === true && util_1.isFn(props.onClick))), props.children)); }));
    };
    /**
     * @stable [23.10.2019]
     * @param {IBaseEvent} event
     */
    GridRow.prototype.onClick = function (event) {
        var props = this.props;
        props.onClick(props.entity);
    };
    return GridRow;
}(base_1.BaseComponent));
exports.GridRow = GridRow;
//# sourceMappingURL=grid-row.component.js.map