import * as React from 'react';
import { ReactLayoutBuilderChildrenT, ILayoutBuilderConfiguration } from '../../../react-configurations-definitions.interface';
import { ReactBaseLayoutViewBuilder } from './react-base-layout-view.builder';
export declare class ReactLayoutViewBuilder extends ReactBaseLayoutViewBuilder {
    /**
     * @stable [22.10.2018]
     * @param {React.HTMLAttributes<{}>} props
     * @param {ReactLayoutBuilderChildrenT[]} children
     * @param {ILayoutBuilderConfiguration} layoutConfig
     * @returns {React.ReactNode}
     */
    buildRowView(props: React.HTMLAttributes<{}>, children: ReactLayoutBuilderChildrenT[], layoutConfig: ILayoutBuilderConfiguration): React.ReactNode;
    /**
     * @stable [22.10.2018]
     * @param {React.HTMLAttributes<{}>} props
     * @param {ReactLayoutBuilderChildrenT[]} children
     * @param {ILayoutBuilderConfiguration} layoutConfig
     * @returns {React.ReactNode}
     */
    buildColumnView(props: React.HTMLAttributes<{}>, children: ReactLayoutBuilderChildrenT[], layoutConfig: ILayoutBuilderConfiguration): React.ReactNode;
    /**
     * @stable [22.10.2018]
     * @param {React.HTMLAttributes<{}>} props
     * @returns {React.ReactNode}
     */
    buildSeparatorView(props: React.HTMLAttributes<{}>): React.ReactNode;
}
