"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var util_1 = require("../../../util");
var react_base_layout_view_builder_1 = require("./react-base-layout-view.builder");
var ReactLayoutViewBuilder = /** @class */ (function (_super) {
    __extends(ReactLayoutViewBuilder, _super);
    function ReactLayoutViewBuilder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [22.10.2018]
     * @param {React.HTMLAttributes<{}>} props
     * @param {ReactLayoutBuilderChildrenT[]} children
     * @param {ILayoutBuilderConfiguration} layoutConfig
     * @returns {React.ReactNode}
     */
    ReactLayoutViewBuilder.prototype.buildRowView = function (props, children, layoutConfig) {
        return (React.createElement("div", __assign({ className: util_1.toClassName('rac-flex', 'rac-flex-row', this.toFactorClassName(layoutConfig)) }, props), children));
    };
    /**
     * @stable [22.10.2018]
     * @param {React.HTMLAttributes<{}>} props
     * @param {ReactLayoutBuilderChildrenT[]} children
     * @param {ILayoutBuilderConfiguration} layoutConfig
     * @returns {React.ReactNode}
     */
    ReactLayoutViewBuilder.prototype.buildColumnView = function (props, children, layoutConfig) {
        return (React.createElement("div", __assign({ className: util_1.toClassName('rac-flex', 'rac-flex-column', this.toFactorClassName(layoutConfig)) }, props), children));
    };
    /**
     * @stable [22.10.2018]
     * @param {React.HTMLAttributes<{}>} props
     * @returns {React.ReactNode}
     */
    ReactLayoutViewBuilder.prototype.buildSeparatorView = function (props) {
        return React.createElement("div", __assign({}, props, { className: 'rac-flex-separator' }));
    };
    return ReactLayoutViewBuilder;
}(react_base_layout_view_builder_1.ReactBaseLayoutViewBuilder));
exports.ReactLayoutViewBuilder = ReactLayoutViewBuilder;
//# sourceMappingURL=react-layout-view.builder.js.map