"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var drawer_1 = require("../../drawer");
var list_1 = require("../../list");
var di_1 = require("../../../di");
var util_1 = require("../../../util");
var layout_container_1 = require("../layout.container");
var header_1 = require("../../header");
var navigation_1 = require("../../../navigation");
var main_1 = require("../../main");
var profile_1 = require("../../profile");
var flex_1 = require("../flex");
var operation_1 = require("../../../operation");
var layout_interface_1 = require("../layout.interface");
var env_1 = require("../../../env");
var menu_1 = require("../../menu");
var link_1 = require("../../link");
var definition_1 = require("../../../definition");
var overlay_1 = require("../../overlay");
var plugin_1 = require("../../plugin");
var DefaultLayoutContainer = /** @class */ (function (_super) {
    __extends(DefaultLayoutContainer, _super);
    /**
     * @stable [18.09.2018]
     * @param {IDefaultLayoutContainerProps} props
     */
    function DefaultLayoutContainer(props) {
        var _this = _super.call(this, props) || this;
        _this.PROFILE_EXIT_ACTION = 'exit';
        _this.PROFILE_PROFILE_ACTION = 'profile';
        _this.USER_MENU_OPTIONS = [
            { label: _this.settings.messages.settingsMessage, icon: 'settings', value: _this.PROFILE_PROFILE_ACTION },
            { label: _this.settings.messages.logOutMessage, icon: 'sign_out_alt', value: _this.PROFILE_EXIT_ACTION }
        ];
        _this.userMenuRef = React.createRef();
        _this.state = { notifications: false };
        _this.onHeaderMoreOptionsSelect = _this.onHeaderMoreOptionsSelect.bind(_this);
        _this.onHeaderNavigationActionClick = _this.onHeaderNavigationActionClick.bind(_this);
        _this.onUserMenuActionClick = _this.onUserMenuActionClick.bind(_this);
        _this.onUserMenuSelect = _this.onUserMenuSelect.bind(_this);
        _this.onLogoMenuActionClick = _this.onLogoMenuActionClick.bind(_this);
        _this.onProfileMenuClick = _this.onProfileMenuClick.bind(_this);
        _this.onNavigationListScroll = _this.onNavigationListScroll.bind(_this);
        _this.onNavigationListGroupClick = _this.onNavigationListGroupClick.bind(_this);
        _this.onNotificationsClick = _this.onNotificationsClick.bind(_this);
        return _this;
    }
    /**
     * @stable [18.09.2018]
     * @returns {JSX.Element}
     */
    DefaultLayoutContainer.prototype.render = function () {
        var props = this.props;
        return (React.createElement(flex_1.FlexLayout, { row: true, className: util_1.joinClassName('rac-default-layout', props.className) },
            this.drawerElement,
            React.createElement(flex_1.FlexLayout, null,
                this.headerElement,
                this.mainElement,
                this.footerElement),
            this.snackbarElement));
    };
    /**
     * @stable [18.09.2018]
     * @param {IBaseEvent} event
     */
    DefaultLayoutContainer.prototype.onUserMenuActionClick = function (event) {
        util_1.cancelEvent(event);
        this.userMenuRef.current.show();
    };
    /**
     * @stable [18.09.2018]
     * @param {IMenuItemEntity} menuItem
     */
    DefaultLayoutContainer.prototype.onUserMenuSelect = function (menuItem) {
        switch (menuItem.value) {
            case this.PROFILE_EXIT_ACTION:
                this.navigate(this.routes.logout);
                break;
            case this.PROFILE_PROFILE_ACTION:
                this.navigate(this.routes.profile);
                break;
        }
    };
    /**
     * @stable [18.09.2018]
     * @param {IStringMenuActionEntity} option
     */
    DefaultLayoutContainer.prototype.onHeaderMoreOptionsSelect = function (option) {
        var params = { payload: operation_1.Operation.create(option.value) };
        this.dispatchFrameworkAction(option.value, params);
    };
    /**
     * @stable [17.10.2018]
     */
    DefaultLayoutContainer.prototype.onLogoMenuActionClick = function () {
        this.navigate(this.routes.home);
    };
    /**
     * @stable [18.09.2018]
     */
    DefaultLayoutContainer.prototype.onHeaderNavigationActionClick = function () {
        var props = this.props;
        var headerConfiguration = props.headerConfiguration;
        if (util_1.isFn(headerConfiguration.onNavigationActionClick)) {
            headerConfiguration.onNavigationActionClick();
        }
    };
    /**
     * @stable [01.12.2018]
     * @param {IXYEntity} xy
     */
    DefaultLayoutContainer.prototype.onNavigationListScroll = function (xy) {
        var payloadWrapper = { payload: xy };
        this.dispatchCustomType(layout_interface_1.LAYOUT_XY_UPDATE_ACTION_TYPE, payloadWrapper);
    };
    /**
     * @stable [23.09.2018]
     * @param {INavigationItemEntity} item
     */
    DefaultLayoutContainer.prototype.onNavigationListGroupClick = function (item) {
        var itemValue = item.value;
        if (R.isNil(itemValue)) {
            return;
        }
        var payloadWrapper = { payload: itemValue };
        this.dispatchCustomType(layout_interface_1.LAYOUT_EXPANDED_GROUPS_UPDATE_ACTION_TYPE, payloadWrapper);
    };
    Object.defineProperty(DefaultLayoutContainer.prototype, "layoutFullModeEnabled", {
        /**
         * @stable [23.09.2018]
         * @returns {boolean}
         */
        get: function () {
            return this.layoutMode === definition_1.LayoutModeEnum.FULL;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayoutContainer.prototype, "layoutMode", {
        /**
         * @stable [23.09.2018]
         * @returns {LayoutModeEnum}
         */
        get: function () {
            return this.props.layout.mode;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayoutContainer.prototype, "menuItems", {
        /**
         * @stable [18.09.2018]
         * @returns {INavigationItemEntity[]}
         */
        get: function () {
            return this.navigationMenuBuilder.provide(this.props);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayoutContainer.prototype, "headerElement", {
        /**
         * @stable [18.09.2018]
         * @returns {JSX.Element}
         */
        get: function () {
            var props = this.props;
            var user = props.user;
            return (React.createElement(header_1.Header, null,
                React.createElement(link_1.Link, { to: this.routes.profile },
                    React.createElement("div", { className: 'rac-user-photo', style: { backgroundImage: "url(" + (user.url || this.settings.emptyPictureUrl) + ")" } }, "\u00A0")),
                React.createElement(link_1.Link, { to: this.routes.profile },
                    React.createElement("div", { className: 'rac-user' }, user.name)),
                this.userMenuElement));
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [11.02.2019]
     */
    DefaultLayoutContainer.prototype.onNotificationsClick = function () {
        this.setState({ notifications: !this.state.notifications });
    };
    Object.defineProperty(DefaultLayoutContainer.prototype, "drawerElement", {
        /**
         * @stable [18.09.2018]
         * @returns {JSX.Element}
         */
        get: function () {
            var props = this.props;
            var layoutFullModeEnabled = this.layoutFullModeEnabled;
            return (React.createElement(drawer_1.Drawer, { mini: !layoutFullModeEnabled },
                React.createElement(flex_1.FlexLayout, { row: true, alignItemsCenter: true, className: 'rac-drawer-toolbar-spacer', onClick: this.onLogoMenuActionClick },
                    React.createElement(profile_1.Profile, { avatarRendered: layoutFullModeEnabled, appVersion: env_1.ENV.appVersion, onClick: this.onProfileMenuClick })),
                React.createElement(list_1.NavigationList, __assign({}, props.layout, { dividerRendered: false, items: this.menuItems, onScroll: this.onNavigationListScroll, onGroupClick: this.onNavigationListGroupClick, plugins: [plugin_1.PersistentScrollPlugin] }))));
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [17.10.2018]
     * @param {IBaseEvent} event
     */
    DefaultLayoutContainer.prototype.onProfileMenuClick = function (event) {
        util_1.cancelEvent(event);
        var payloadWrapper = { payload: this.layoutMode };
        this.dispatchCustomType(layout_interface_1.LAYOUT_MODE_UPDATE_ACTION_TYPE, payloadWrapper);
    };
    Object.defineProperty(DefaultLayoutContainer.prototype, "mainElement", {
        /**
         * @stable [08.10.2018]
         * @returns {JSX.Element}
         */
        get: function () {
            var props = this.props;
            var runtimeTitle = this.menuItems.find(function (item) { return item.active; });
            var title = props.title || (runtimeTitle && runtimeTitle.label);
            return (React.createElement(main_1.Main, { plugins: [plugin_1.StickyHeaderPlugin, plugin_1.SelectedElementPlugin] },
                React.createElement(header_1.SubHeader, __assign({}, props.headerConfiguration, { title: title, onNavigationActionClick: this.onHeaderNavigationActionClick, onMoreOptionsSelect: this.onHeaderMoreOptionsSelect })),
                this.props.children,
                this.mainProgressOverlayElement,
                this.notificationsElement));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayoutContainer.prototype, "footerElement", {
        /**
         * @stable [08.10.2018]
         * @returns {JSX.Element}
         */
        get: function () {
            var props = this.props;
            var footer = props.footer;
            return util_1.orNull(props.footerRendered, footer);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayoutContainer.prototype, "mainProgressOverlayElement", {
        /**
         * @stable [18.03.2019]
         * @returns {JSX.Element}
         */
        get: function () {
            return util_1.orNull(this.props.progress, function () { return React.createElement(overlay_1.Overlay, { progress: true }); });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayoutContainer.prototype, "notificationsElement", {
        /**
         * @stable [11.02.2019]
         * @returns {JSX.Element}
         */
        get: function () {
            return util_1.orNull(this.state.notifications, function () { return (React.createElement(flex_1.FlexLayout, { className: 'rac-notifications' }, "3 new notifications")); });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayoutContainer.prototype, "userMenuElement", {
        /**
         * @stable [18.09.2018]
         * @returns {JSX.Element}
         */
        get: function () {
            return (React.createElement("div", null,
                this.uiFactory.makeIcon({
                    type: 'more_hor',
                    className: 'rac-user-menu',
                    onClick: this.onUserMenuActionClick,
                }),
                React.createElement(menu_1.Menu, { ref: this.userMenuRef, options: this.USER_MENU_OPTIONS, onSelect: this.onUserMenuSelect })));
        },
        enumerable: true,
        configurable: true
    });
    DefaultLayoutContainer.defaultProps = {
        headerConfiguration: {},
        footerRendered: true,
    };
    __decorate([
        di_1.lazyInject(navigation_1.NavigationMenuBuilder),
        __metadata("design:type", navigation_1.NavigationMenuBuilder)
    ], DefaultLayoutContainer.prototype, "navigationMenuBuilder", void 0);
    return DefaultLayoutContainer;
}(layout_container_1.LayoutContainer));
exports.DefaultLayoutContainer = DefaultLayoutContainer;
//# sourceMappingURL=default-layout.container.js.map