"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var snackbar_1 = require("../snackbar");
var basic_container_1 = require("../base/basic.container");
var notification_1 = require("../../notification");
var LayoutContainer = /** @class */ (function (_super) {
    __extends(LayoutContainer, _super);
    /**
     * @stable [19.08.2018]
     * @param {TProps} props
     */
    function LayoutContainer(props) {
        var _this = _super.call(this, props) || this;
        _this.clearAllNotifications = _this.clearAllNotifications.bind(_this);
        return _this;
    }
    Object.defineProperty(LayoutContainer.prototype, "snackbarElement", {
        /**
         * @stable [19.08.2018]
         * @returns {JSX.Element}
         */
        get: function () {
            var notification = this.props.notification;
            var message = notification && (notification.error || notification.info);
            return ( // TODO
            React.createElement(snackbar_1.Snackbar, { message: message, error: !R.isNil(notification.error), afterShow: this.clearAllNotifications }));
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [19.08.2018]
     */
    LayoutContainer.prototype.clearAllNotifications = function () {
        this.dispatchCustomType(notification_1.NOTIFICATION_CLEAR_ACTION_TYPE);
    };
    return LayoutContainer;
}(basic_container_1.BasicContainer));
exports.LayoutContainer = LayoutContainer;
//# sourceMappingURL=layout.container.js.map