"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var dialog_1 = require("@material/dialog");
var material_plugin_1 = require("./material.plugin");
var util_1 = require("../../../util");
var DialogMaterialPlugin = /** @class */ (function (_super) {
    __extends(DialogMaterialPlugin, _super);
    /**
     * @stable [04.10.2018]
     * @param {TDialog} dialog
     */
    function DialogMaterialPlugin(dialog) {
        var _this = _super.call(this, dialog, dialog_1.MDCDialog) || this;
        _this.onDialogClosed = _this.onDialogClosed.bind(_this);
        dialog.activate = util_1.sequence(dialog.activate, _this.activate, _this);
        dialog.onAccept = util_1.sequence(dialog.onAccept, _this.deactivate, _this);
        dialog.onClose = util_1.sequence(dialog.onClose, _this.deactivate, _this);
        return _this;
    }
    /**
     * @stable [17.06.2019]
     */
    DialogMaterialPlugin.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        if (this.doesMdcExist) {
            this.mdc.listen('MDCDialog:closed', this.onDialogClosed);
        }
    };
    /**
     * @stable [17.06.2019]
     */
    DialogMaterialPlugin.prototype.activate = function () {
        this.mdc.open();
    };
    /**
     * @stable [04.10.2018]
     */
    DialogMaterialPlugin.prototype.deactivate = function () {
        this.mdc.close();
    };
    /**
     * @stable [17.06.2019]
     */
    DialogMaterialPlugin.prototype.onDialogClosed = function () {
        var onDeactivateFn = this.component.onDeactivate;
        if (util_1.isFn(onDeactivateFn)) {
            onDeactivateFn.call(this.component);
        }
    };
    return DialogMaterialPlugin;
}(material_plugin_1.MaterialPlugin));
exports.DialogMaterialPlugin = DialogMaterialPlugin;
//# sourceMappingURL=dialog-material.plugin.js.map