import { INativeMaterialComponent, INativeMaterialAdapter } from '../../../entities-definitions.interface';
import { INativeMaterialComponentFactory } from '../../material';
import { TranslatorT } from '../../../translation';
import { IUniversalPlugin, IComponent } from '../../../definition';
export declare class MaterialPlugin<TComponent extends IComponent, TNativeMaterialComponent extends INativeMaterialComponent = INativeMaterialComponent> implements IUniversalPlugin {
    protected component: TComponent;
    private mdcFactory;
    protected mdc: TNativeMaterialComponent;
    /**
     * @stable [18.06.2019]
     * @param {TComponent} component
     * @param {INativeMaterialComponentFactory<TNativeMaterialComponent extends INativeMaterialComponent>} mdcFactory
     */
    constructor(component: TComponent, mdcFactory: INativeMaterialComponentFactory<TNativeMaterialComponent>);
    /**
     * @stable [31.08.2018]
     */
    componentDidMount(): void;
    /**
     * @stable [05.05.2018]
     */
    componentWillUnmount(): void;
    /**
     * @stable [15.08.2018]
     */
    protected readonly adapter: INativeMaterialAdapter;
    /**
     * @stable [17.06.2019]
     * @returns {boolean}
     */
    protected readonly doesMdcExist: boolean;
    /**
     * @stable [22.08.2018]
     * @returns {TranslatorT}
     */
    protected readonly t: TranslatorT;
}
