/// <reference types="react" />
import { BaseComponent } from '../base/base.component';
import { IMenu, IMenuProps, IMenuState } from '../../definition';
export declare class Menu extends BaseComponent<IMenuProps, IMenuState> implements IMenu {
    static readonly defaultProps: IMenuProps;
    private readonly dialogRef;
    private readonly fieldRef;
    private readonly menuAnchorRef;
    private readonly filterQueryTask;
    private syntheticScrollEventUnsubscriber;
    private resizeUnsubscriber;
    /**
     * @stable [31.07.2018]
     * @param {IMenuProps} props
     */
    constructor(props: IMenuProps);
    /**
     * @stable [18.06.2019]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [18.06.2019]
     */
    componentWillUnmount(): void;
    /**
     * @stable [17.06.2019]
     * @returns {boolean}
     */
    readonly centeredMenu: boolean;
    /**
     * @stable [04.10.2018]
     */
    show(): void;
    /**
     * @stable [18.06.2019]
     */
    hide(): void;
    /**
     * @stable [29.11.2018]
     * @returns {boolean}
     */
    isOpen(): boolean;
    /**
     * @stable [23.11.2019]
     * @returns {IMenuItemEntity[]}
     */
    private readonly items;
    /**
     * @stable [23.11.2019]
     * @param {string} filter
     */
    private onFilterValueChange;
    /**
     * @stable [23.11.2019]
     */
    private onFilterValueDelayedChange;
    /**
     * @stable [23.11.2019]
     * @param {IMenuItemEntity} option
     */
    private onSelect;
    /**
     * @stable [17.06.2019]
     */
    private onDialogDeactivate;
    /**
     * @stable [23.11.2019]
     */
    private unsubscribeAllCaptureEvents;
    /**
     * @stable [23.09.2019]
     * @returns {JSX.Element}
     */
    private readonly listElement;
    /**
     * @stable [23.09.2019]
     * @param {IMenuItemEntity} option
     * @returns {JSX.Element}
     */
    private getItemElement;
    /**
     * @stable [17.06.2019]
     * @returns {JSX.Element}
     */
    private readonly filterElement;
    /**
     * @stable [06.07.2019]
     * @returns {JSX.Element}
     */
    private readonly closeActionElement;
    /**
     * @stable [23.11.2019]
     * @returns {boolean}
     */
    private readonly isFilterUsed;
    /**
     * @stable [17.05.2019]
     * @returns {boolean}
     */
    private readonly doesDialogExist;
    /**
     * @stable [07.06.2018]
     * @returns {IField}
     */
    private readonly field;
    /**
     * @stable [17.06.2019]
     * @returns {Dialog<AnyT>}
     */
    private readonly dialog;
    /**
     * @stable [17.06.2019]
     * @param {IMenuItemEntity} itm
     * @returns {StringNumberT}
     */
    private readonly optionValueFn;
}
