import * as React from 'react';
import { BaseStoreProxy } from '../base-store.proxy';
import { IDialogFormChangesConfirmStoreProxy, IUniversalComponentProps, IUniversalContainer, IUniversalContainerProps, IUniversalDialog, IUniversalStoreEntity } from '../../../../definition';
export declare class DialogFormChangesConfirmStoreProxy<TStore extends IUniversalStoreEntity = IUniversalStoreEntity, TProps extends IUniversalContainerProps = IUniversalContainerProps> extends BaseStoreProxy<TStore, TProps> implements IDialogFormChangesConfirmStoreProxy {
    readonly container: IUniversalContainer<TProps>;
    readonly dialogRef: React.RefObject<IUniversalDialog<IUniversalComponentProps, {}>>;
    /**
     * @stable [09.10.2019]
     * @param {IUniversalContainer<TProps extends IUniversalContainerProps>} container
     */
    constructor(container: IUniversalContainer<TProps>);
    /**
     * @stable [03.10.2019]
     */
    activateDialog(): void;
    /**
     * @stable [03.10.2019]
     */
    goBack(): void;
    /**
     * @stable [03.10.2019]
     * @returns {React.RefObject<T extends IUniversalDialog>}
     */
    getDialogRef<T extends IUniversalDialog>(): React.RefObject<T>;
}
