"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var base_store_proxy_1 = require("../base-store.proxy");
var definition_1 = require("../../../../definition");
var DialogFormChangesConfirmStoreProxy = /** @class */ (function (_super) {
    __extends(DialogFormChangesConfirmStoreProxy, _super);
    /**
     * @stable [09.10.2019]
     * @param {IUniversalContainer<TProps extends IUniversalContainerProps>} container
     */
    function DialogFormChangesConfirmStoreProxy(container) {
        var _this = _super.call(this, container) || this;
        _this.container = container;
        _this.dialogRef = React.createRef();
        _this.goBack = _this.goBack.bind(_this);
        _this.activateDialog = _this.activateDialog.bind(_this);
        return _this;
    }
    /**
     * @stable [03.10.2019]
     */
    DialogFormChangesConfirmStoreProxy.prototype.activateDialog = function () {
        this.dialogRef.current.activate();
    };
    /**
     * @stable [03.10.2019]
     */
    DialogFormChangesConfirmStoreProxy.prototype.goBack = function () {
        this.dispatchCustomType(definition_1.ROUTER_BACK_ACTION_TYPE);
    };
    /**
     * @stable [03.10.2019]
     * @returns {React.RefObject<T extends IUniversalDialog>}
     */
    DialogFormChangesConfirmStoreProxy.prototype.getDialogRef = function () {
        return this.dialogRef;
    };
    return DialogFormChangesConfirmStoreProxy;
}(base_store_proxy_1.BaseStoreProxy));
exports.DialogFormChangesConfirmStoreProxy = DialogFormChangesConfirmStoreProxy;
//# sourceMappingURL=dialog-form-changes-confirm-store.proxy.js.map