"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var base_store_proxy_1 = require("../base-store.proxy");
var dictionary_1 = require("../../../../dictionary");
var DictionaryStoreProxy = /** @class */ (function (_super) {
    __extends(DictionaryStoreProxy, _super);
    /**
     * @stable [09.10.2019]
     * @param {IUniversalContainer<TProps extends IUniversalContainerProps>} container
     */
    function DictionaryStoreProxy(container) {
        var _this = _super.call(this, container) || this;
        _this.container = container;
        _this.dispatchLoadDictionary = _this.dispatchLoadDictionary.bind(_this);
        return _this;
    }
    /**
     * @stable [09.10.2019]
     * @param {string} dictionary
     * @param {TData} data
     */
    DictionaryStoreProxy.prototype.dispatchLoadDictionary = function (dictionary, data) {
        this.dispatchAnyAction(dictionary_1.DictionariesActionBuilder.buildLoadAction(dictionary, data));
    };
    return DictionaryStoreProxy;
}(base_store_proxy_1.BaseStoreProxy));
exports.DictionaryStoreProxy = DictionaryStoreProxy;
//# sourceMappingURL=dictionary-store.proxy.js.map