/// <reference types="react" />
import { BaseContainer } from '../base';
import { ITabPanelContainerProps } from './tabpanel.interface';
import { IPayloadWrapper } from '../../definitions.interface';
export declare class TabPanelContainer<TProps extends ITabPanelContainerProps = ITabPanelContainerProps> extends BaseContainer<TProps> {
    /**
     * @stable [30.08.2018]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [30.08.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [30.08.2018]
     * @returns {number}
     */
    protected getTabActiveValue(): number;
    /**
     * @stable [30.08.2018]
     * @param {IPayloadWrapper<number>} payloadWrapper
     */
    protected dispatchActiveValue(payloadWrapper: IPayloadWrapper<number>): void;
    /**
     * @stable [30.08.2018]
     * @param {IPayloadWrapper<number>} payloadWrapper
     */
    protected dispatchDeactivatedValue(payloadWrapper: IPayloadWrapper<number>): void;
    /**
     * @stable [30.08.2018]
     * @param {ITabConfiguration} tab
     */
    private onTabClick;
    /**
     * @stable [02.09.2018]
     * @param {number} activeValue
     */
    private onDeactivate;
}
