import { IBlockWrapper, IBooleanIconLeftWrapper, IBooleanTransparentWrapper, IBorderedWrapper, IButtonConfigurationWrapper, IDefaultOnPressWrapper, IDisabledWrapper, IErrorMessageWrapper, IFullWrapper, IIconStyleWrapper, IIconWrapper, IKeyValue, ILargeWrapper, IMiniWrapper, IOnClickWrapper, IOutlinedWrapper, IProgressMessageWrapper, IProgressWrapper, IRaisedWrapper, IRippledWrapper, IRoundedWrapper, ISmallWrapper, IStyleWrapper, ISuccessWrapper, ITextStyleWrapper, ITextWrapper, ITouchedWrapper, IToWrapper, ITypeWrapper } from '../definitions.interface';
import { IErrorEntity } from './error-definition.interface';
import { IUniversalComponentEntity } from './component-definition.interface';
import { IComponentProps } from './props-definition.interface';
/**
 * @cross-platform
 * @stable [13.02.2019]
 */
export interface IGenericButtonEntity extends IDisabledWrapper, IErrorEntity, IErrorMessageWrapper, IFullWrapper, IIconWrapper<string | boolean>, IMiniWrapper, IOutlinedWrapper, IProgressMessageWrapper, IProgressWrapper, IRaisedWrapper, IRippledWrapper, ITextWrapper, ITouchedWrapper, IToWrapper, ITypeWrapper<'button' | 'submit' | 'reset'> {
}
/**
 * @stable [27.09.2019]
 */
export interface IButtonEntity extends IGenericButtonEntity, IOnClickWrapper {
}
/**
 * @stable [27.09.2019]
 */
export interface IButtonProps extends IComponentProps, IButtonEntity {
}
/**
 * @stable [26.10.2019]
 */
export interface IButtonConfigurationWrapperEntity extends IButtonConfigurationWrapper<IButtonProps> {
}
export interface IRnButtonEntity extends IUniversalComponentEntity, IBorderedWrapper, IRoundedWrapper, ISuccessWrapper, IBlockWrapper, ISmallWrapper, ILargeWrapper, IBooleanIconLeftWrapper, IBooleanTransparentWrapper, IIconStyleWrapper<IKeyValue>, ITextStyleWrapper<IKeyValue>, IStyleWrapper<IKeyValue>, IDefaultOnPressWrapper {
}
export interface IRnButtonProps extends IGenericButtonEntity, IRnButtonEntity {
}
/**
 * @stable [16.10.2019]
 */
export declare const DEFAULT_FLEX_BUTTON_CLASS_NAMES: ReadonlyArray<string>;
