import { ITypeWrapper } from '../definitions.interface';
/**
 * @stable [15.11.2019]
 */
export declare enum CronPartTypesEnum {
    DAY_OF_MONTH = 0,
    DAY_OF_WEEK = 1,
    HOUR = 2,
    MINUTE = 3,
    MONTH_OF_YEAR = 4,
    YEAR = 5
}
/**
 * @stable [15.11.2019]
 */
export declare const CRON_PART_TYPE_RANGES: Readonly<{
    [cronPartType: string]: number[];
}>;
/**
 * @stable [15.11.2019]
 */
export interface ICronEntity {
    daysOfMonths: number[];
    daysOfWeeks: number[];
    hours: number[];
    minutes: number[];
    months: number[];
    years: number[];
}
/**
 * @stable [15.11.2019]
 */
export interface ICronPartEntity extends ITypeWrapper<CronPartTypesEnum> {
}
