"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @stable [09.10.2019]
 */
var RegexpEnum;
(function (RegexpEnum) {
    RegexpEnum["PRICE"] = "\\d+(\\.\\d{1,2})?";
    RegexpEnum["NUMBER"] = "[-+]?[0-9]*[.,]?[0-9]+";
    RegexpEnum["DIGITAL"] = "[0-9]+";
})(RegexpEnum = exports.RegexpEnum || (exports.RegexpEnum = {}));
/**
 * @stable [15.10.2019]
 */
exports.DEFAULT_CURRENCY_SETTINGS_ENTITY = Object.freeze({
    uiLocale: 'en-US',
    uiCurrency: 'USD',
    uiShortCurrency: '$',
});
/**
 * @stable [29.11.0219]
 */
exports.DEFAULT_PHONE_SETTINGS_ENTITY = Object.freeze({
    uiCountryAbbreviation: 'US',
    uiMask: ['+', /\d/, '(', /\d/, /\d/, /\d/, ')', /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/],
});
/**
 * @stable [07.10.2019]
 */
exports.DEFAULT_MESSAGES_SETTINGS_ENTITY = Object.freeze({
    APPLICATION_IS_INITIALIZING: 'The app is initializing...',
    BUILD: 'Build',
    DETAILS_INFO: 'Details info',
    ENVIRONMENT: 'Environment',
    ERROR: 'Error',
    FILTER_PLACEHOLDER: 'Search',
    NEW_APP_VERSION_HAS_BEEN_DEPLOYED: 'The app has been updated! Let\'s go to the main page',
    PATH: 'Path',
    PLEASE_WAIT: 'Please wait...',
    PLS_SEND_THIS_SCR_TO_SUPPORT_MANAGER: 'Please send this screenshot to your support manager',
    RESTART_APP: 'Restart App',
    SOMETHING_WENT_WRONG: 'Something went wrong',
    UNKNOWN_ERROR: 'Unknown error',
    USER: 'User',
});
//# sourceMappingURL=settings-definition.interface.js.map