"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var util_1 = require("../util");
var dictionaries_interface_1 = require("./dictionaries.interface");
var DictionariesActionBuilder = /** @class */ (function () {
    function DictionariesActionBuilder() {
    }
    /**
     * @stable [09.10.2019]
     * @param {string} section
     * @returns {string}
     */
    DictionariesActionBuilder.buildLoadActionType = function (section) {
        return section + "." + dictionaries_interface_1.DICTIONARY_LOAD_ACTION_TYPE;
    };
    DictionariesActionBuilder.buildClearActionType = function (section) {
        return section + "." + dictionaries_interface_1.DICTIONARY_CLEAR_ACTION_TYPE;
    };
    DictionariesActionBuilder.buildLoadDoneActionType = function (section) {
        return section + "." + dictionaries_interface_1.DICTIONARY_LOAD_ACTION_TYPE + ".done";
    };
    DictionariesActionBuilder.buildLoadErrorActionType = function (section) {
        return section + "." + dictionaries_interface_1.DICTIONARY_LOAD_ACTION_TYPE + ".error";
    };
    DictionariesActionBuilder.buildDestroyAction = function () {
        return redux_effects_promise_1.EffectsAction.create(dictionaries_interface_1.DICTIONARIES_DESTROY_ACTION_TYPE);
    };
    /**
     * @stable [09.10.2019]
     * @param {string} section
     * @param {IKeyValue} data
     * @returns {IEffectsAction}
     */
    DictionariesActionBuilder.buildLoadAction = function (section, data) {
        return redux_effects_promise_1.EffectsAction.create(this.buildLoadActionType(section), util_1.applySection(section, data));
    };
    return DictionariesActionBuilder;
}());
exports.DictionariesActionBuilder = DictionariesActionBuilder;
//# sourceMappingURL=dictionaries-action.builder.js.map