import { AnyT } from '../definitions.interface';
import { IButtonProps, ICurrencySettingsEntity, IMessagesSettingsEntity, IPhoneSettingsEntity, IStorageSettingsEntity, ITransportSettingsEntity, StorageTypesEnum } from '../definition';
export interface IApplicationResourcePaths {
    uiDefaultIconPath?: string;
}
export declare enum StartDayOfWeekT {
    MONDAY = 0,
    SUNDAY = 1
}
export interface IDateTimeSettings {
    yearPlaceholder?: string;
    startDayOfWeek?: StartDayOfWeekT;
    currentDate?: Date;
    timeZone?: string;
    dateFormat?: string;
    timeFormat?: string;
    dateTimeFormat?: string;
    uiDateFormat?: string;
    uiMonthFormat?: string;
    uiTimeFormat?: string;
    pstDateFormat?: string;
    pstTimeFormat?: string;
    uiDateMask?: Array<string | RegExp>;
    uiTimeMask?: Array<string | RegExp>;
    uiShortTimeMask?: Array<string | RegExp>;
    uiDatePattern?: string;
    uiTimePattern?: string;
    uiShortTimePattern?: string;
}
export interface IApplicationNumberSettings {
    uiPattern?: string;
}
/**
 * @stable [10.03.2019]
 */
export interface IMessagesSettings extends IMessagesSettingsEntity {
    acceptMessage?: string;
    accessDeniedMessage?: string;
    addressSelectionMessage?: string;
    applyMessage?: string;
    appNotReadyMessage?: string;
    clearAllMessage?: string;
    closeMessage?: string;
    confirmationMessage?: string;
    continueMessage?: string;
    create?: string;
    dataSaved?: string;
    defaultErrorMessage?: string;
    dialogAcceptMessage?: string;
    dialogCancelMessage?: string;
    dialogTitleMessage?: string;
    dndMessage?: string;
    emptyDataMessage?: string;
    emptyMessage?: string;
    errorMessage?: string;
    exportActionTitleMessage?: string;
    fileLoadErrorMessage?: string;
    filtersMessage?: string;
    invalidAddressMessage?: string;
    logOutMessage?: string;
    logoutNotificationMessage?: string;
    noAvailableItemsToSelectMessage?: string;
    noItemsMessage?: string;
    pagesMessage?: string;
    previewMessage?: string;
    putMarkerHereMessage?: string;
    refreshActionTitleMessage?: string;
    requestCancelErrorMessage?: string;
    reset?: string;
    save?: string;
    serviceTemporarilyUnavailableMessage?: string;
    settingsMessage?: string;
    simplePagesMessage?: string;
    sorryMessage?: string;
    takeSnapshotMessage?: string;
    unknownFileMessage?: string;
    waitingMessage?: string;
    waitMessage?: string;
    welcomeMessage?: string;
    yearMessage?: string;
    yearPlaceholderMessage?: string;
}
export interface IAuthorizationSettings {
    isAuthorizationNeeded?: boolean;
}
export interface IApplicationChannelSettings {
    eventToListen?: string;
    eventToEmit?: string;
}
export interface IGoogleMapsSettings {
    lat?: number;
    lng?: number;
    zoom?: number;
    prettyZoom?: number;
    libraries?: string;
}
export interface IComponentsSettings {
    button?: IButtonProps;
}
export interface IBootstrapSettings {
    flexEnabled?: boolean;
    rootId?: string;
}
export interface ISettingsEntity {
    authorization?: IAuthorizationSettings;
    bootstrap?: IBootstrapSettings;
    channel?: IApplicationChannelSettings;
    companyCountry?: string;
    companyName?: string;
    components?: IComponentsSettings;
    currency?: ICurrencySettingsEntity;
    dateTime?: IDateTimeSettings;
    downloadUrl?: string;
    emptyPictureUrl?: string;
    entityEmptyId?: AnyT;
    googleMaps?: IGoogleMapsSettings;
    messages?: IMessagesSettings;
    metaFilesUrl?: string;
    number?: IApplicationNumberSettings;
    pdfWorkerDirectoryUrl?: string;
    persistenceStorage?: StorageTypesEnum;
    phone?: IPhoneSettingsEntity;
    resourcePaths?: IApplicationResourcePaths;
    signalRUrl?: string;
    storage?: IStorageSettingsEntity;
    transport?: ITransportSettingsEntity;
}
export declare const DEFAULT_APPLICATION_SETTINGS: ISettingsEntity;
