"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var action_builder_1 = require("../../component/action.builder");
var util_1 = require("../../util");
var router_1 = require("../../router");
var stack_1 = require("../stack");
/**
 * @stable [28.08.2019]
 * @param {IChainedFormMiddlewareConfigEntity} config
 * @returns {IEffectsAction[]}
 */
exports.makeChainedFormMiddleware = function (config) {
    return [
        stack_1.StackActionBuilder.buildLockAction(config.nextFormSection),
        // Need to call reset the previous form because "lock". We cannot use destroy because "listeners" + "active value"
        action_builder_1.FormActionBuilder.buildResetAction(config.previousFormSection)
    ].concat(util_1.ifNotNilThanValue(config.nextListSection, 
    // Clear previous created entity applied to the list. We cannot use destroy because "listeners"
    function () { return [action_builder_1.ListActionBuilder.buildResetAction(config.nextListSection)]; }, []), util_1.ifNotNilThanValue(config.nextFormChanges, function () { return [action_builder_1.FormActionBuilder.buildChangesAction(config.nextFormSection, config.nextFormChanges)]; }, []), [
        config.replaceRoute === true
            ? router_1.RouterActionBuilder.buildReplaceAction(config.nextFormRoute)
            : router_1.RouterActionBuilder.buildNavigateAction(config.nextFormRoute)
    ]);
};
//# sourceMappingURL=chained-form.middleware.js.map