import { ITransportFactory, ITransportRequestEntity, ITransportResponseFactoryEntity } from '../../definition';
export declare class TransportFactory implements ITransportFactory {
    private readonly cancelUuid;
    private readonly operationsIdsMap;
    private readonly settings;
    private readonly requestProvider;
    private readonly requestPayloadFactory;
    private readonly responseFactory;
    /**
     * @stable [11.08.2019]
     * @param {ITransportRequestEntity} req
     * @param {(payload: ITransportRequestEntity) => ITransportRequestEntity} requestPayloadHandler
     * @returns {Promise<ITransportResponseFactoryEntity>}
     */
    request(req: ITransportRequestEntity, requestPayloadHandler?: (payload: ITransportRequestEntity) => ITransportRequestEntity): Promise<ITransportResponseFactoryEntity>;
    /**
     * @stable [07.02.2019]
     * @param {ITransportRequestEntity} req
     */
    cancelRequest(req: ITransportRequestEntity): void;
    /**
     * @stable [01.02.2019]
     * @param {string} operationId
     */
    private clearOperation;
    /**
     * @stable [02.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {ITransportResponseFactory}
     */
    private getResponseFactory;
    /**
     * @stable [16.09.2019]
     * @param {ITransportRequestEntity} req
     * @returns {ITransportRequestProvider}
     */
    private getRequestProvider;
    /**
     * @stable [07.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {string}
     */
    private toOperationId;
}
