import { IEntity } from '../definitions.interface';
import { IEditableEntity, IExtendedEntity, IFormWrapperEntity, IMultiEntity } from '../definition';
import { ValidatorRuleEnum } from './validator';
/**
 * @stable [30.01.2019]
 * @param {Record<string, ValidatorRuleEnum[]>} payloads
 * @param {IEditableEntity<TEntity extends IEntity>} editableEntity
 * @param {boolean} canSaveEmptyChanges
 * @returns {boolean}
 */
export declare const canSubmitEditableEntity: <TEntity extends IEntity>(payloads: Record<string, ValidatorRuleEnum[]>, editableEntity: IEditableEntity<TEntity>, canSaveEmptyChanges?: boolean) => boolean;
/**
 * @stable [30.01.2019]
 * @param {IFormWrapperEntity<TEntity extends IEntity>} entity
 * @param {Record<string, ValidatorRuleEnum[]>} editRules
 * @param {Record<string, ValidatorRuleEnum[]>} createRules
 * @returns {boolean}
 */
export declare const canSubmitEntityFormEntity: <TEntity extends IEntity>(entity: IFormWrapperEntity<TEntity>, editRules: Record<string, ValidatorRuleEnum[]>, createRules?: Record<string, ValidatorRuleEnum[]>) => boolean;
/**
 * @stable [19.10.2019]
 * @param {TEntity} entity
 * @returns {boolean}
 */
export declare const isNewEntity: <TEntity extends IEntity>(entity: TEntity) => boolean;
/**
 * @stable [01.10.2019]
 * @param {IExtendedEntity<TEntity extends IEntity>} extendedEntity
 * @returns {boolean}
 */
export declare const isNewExtendedEntity: <TEntity extends IEntity>(extendedEntity: IExtendedEntity<TEntity>) => boolean;
/**
 * @stable [01.10.2019]
 * @param {IExtendedEntity<TEntity extends IEntity>} extendedEntity
 * @returns {boolean}
 */
export declare const doesExtendedEntityExist: <TEntity extends IEntity>(extendedEntity: IExtendedEntity<TEntity>) => boolean;
/**
 * @stable [30.08.2019]
 * @param {TEntity} entity
 * @returns {string}
 */
export declare const entityAsFileName: <TEntity extends IEntity>(entity: TEntity) => string;
/**
 * @stable [12.10.2019]
 * @param {MultiFieldEntityT | EntityIdT} value
 * @returns {boolean}
 */
export declare const isNotMultiEntity: (value: string | number | IEntity[] | IMultiEntity<IEntity>) => boolean;
