"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var type_1 = require("./type");
var di_services_1 = require("../di/di.services");
/**
 * @stable [02.12.2019]
 * @param {React.Component<{}, {}>} scope
 */
exports.patchRenderMethod = function (scope) {
    var originalRenderer = scope.render;
    if (!type_1.isFn(originalRenderer)) {
        return;
    }
    scope.render = function () {
        try {
            return originalRenderer.call(scope);
        }
        catch (e) {
            return di_services_1.getUiFactory().makeReactError(e);
        }
    };
};
//# sourceMappingURL=patch.js.map