"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @stable [02.10.2019]
 * @param {AnyT} value
 * @returns {boolean}
 */
exports.isDef = function (value) { return !exports.isUndef(value); };
/**
 * @stable [02.10.2019]
 * @param {AnyT} value
 * @returns {boolean}
 */
exports.isUndef = function (value) { return typeof value === 'undefined'; };
function isNull(value) {
    return value === null;
}
exports.isNull = isNull;
/**
 * @stable [02.10.2019]
 * @param {AnyT} value
 * @returns {boolean}
 */
exports.isFn = function (value) { return typeof value === 'function'; };
/**
 * @stable [01.08.2018]
 * @param {AnyT} value
 * @returns {boolean}
 */
exports.isNumber = function (value) { return typeof value === 'number'; };
/**
 * @stable [01.08.2018]
 * @param {AnyT} value
 * @returns {boolean}
 */
exports.isNumberLike = function (value) { return /^-?[0-9]\d*(\.\d+)?$/.test(String(value)); };
function isBoolean(value) {
    return typeof value === 'boolean';
}
exports.isBoolean = isBoolean;
/**
 * @stable [23.09.2019]
 * @param {AnyT} value
 * @returns {boolean}
 */
exports.isString = function (value) { return typeof value === 'string'; };
/**
 * @stable [03.10.2019]
 * @param {AnyT} v
 * @returns {boolean}
 */
exports.isPrimitive = function (v) { return exports.isNumber(v) || exports.isString(v) || isBoolean(v); };
/**
 * @stable [03.10.2019]
 * @param {AnyT} v
 * @returns {boolean}
 */
exports.isObject = function (v) { return Object.prototype.toString.call(v) === '[object Object]'; };
/**
 * @stable [06.12.2018]
 * @param {TResult} result
 * @returns {TResult}
 */
exports.toType = function (result) { return result; };
//# sourceMappingURL=type.js.map